require "test_helper"

class TestMapkick < Minitest::Test
  include Mapkick::Helper

  def setup
    @state_data = {"AK"=>20, "AL"=>17, "AR"=>16, "AZ"=>25, "CA"=>10, "CO"=>21, "CT"=>22, "DE"=>32, "FL"=>22, "GA"=>21, "HI"=>19, "IA"=>20, "ID"=>16, "IL"=>15, "IN"=>24, "KS"=>16, "KY"=>23, "LA"=>17, "MA"=>26, "MD"=>22, "ME"=>14, "MI"=>26, "MN"=>20, "MO"=>15, "MS"=>22, "MT"=>19, "NC"=>17, "ND"=>17, "NE"=>19, "NH"=>21, "NJ"=>20, "NM"=>15, "NV"=>12, "NY"=>29, "OH"=>16, "OK"=>17, "OR"=>30, "PA"=>16, "RI"=>23, "SC"=>22, "SD"=>21, "TN"=>21, "TX"=>26, "UT"=>22, "VA"=>18, "VT"=>20, "WA"=>15, "WI"=>20, "WV"=>26, "WY"=>17}
    @country_data = {"ABW"=>3, "AFG"=>3, "AGO"=>2, "AIA"=>2, "ALA"=>6, "ALB"=>2, "AND"=>3, "ARE"=>4, "ARG"=>3, "ARM"=>6, "ASM"=>2, "ATA"=>5, "ATF"=>3, "ATG"=>3, "AUS"=>5, "AUT"=>1, "AZE"=>1, "BDI"=>2, "BEL"=>2, "BEN"=>6, "BES"=>1, "BFA"=>2, "BGD"=>5, "BGR"=>5, "BHR"=>1, "BHS"=>4, "BIH"=>5, "BLM"=>7, "BLR"=>3, "BLZ"=>4, "BMU"=>4, "BOL"=>2, "BRA"=>4, "BRB"=>2, "BRN"=>5, "BTN"=>5, "BVT"=>4, "BWA"=>1, "CAF"=>3, "CAN"=>1, "CCK"=>5, "CHE"=>5, "CHL"=>4, "CHN"=>2, "CIV"=>2, "CMR"=>4, "COD"=>2, "COG"=>6, "COK"=>5, "COL"=>6, "COM"=>6, "CPV"=>8, "CRI"=>4, "CUB"=>4, "CUW"=>8, "CXR"=>3, "CYM"=>6, "CYP"=>3, "CZE"=>8, "DEU"=>2, "DJI"=>7, "DMA"=>5, "DNK"=>4, "DOM"=>2, "DZA"=>6, "ECU"=>6, "EGY"=>3, "ERI"=>4, "ESH"=>3, "ESP"=>3, "EST"=>5, "ETH"=>3, "FIN"=>3, "FJI"=>2, "FLK"=>5, "FRA"=>1, "FRO"=>5, "FSM"=>5, "GAB"=>4, "GBR"=>4, "GEO"=>1, "GGY"=>2, "GHA"=>5, "GIB"=>11, "GIN"=>3, "GLP"=>3, "GMB"=>5, "GNB"=>8, "GNQ"=>9, "GRD"=>6, "GRL"=>2, "GTM"=>5, "GUF"=>6, "GUM"=>4, "GUY"=>4, "HKG"=>3, "HMD"=>4, "HND"=>3, "HRV"=>6, "HTI"=>2, "HUN"=>1, "IDN"=>8, "IMN"=>5, "IND"=>8, "IOT"=>2, "IRL"=>4, "IRN"=>8, "IRQ"=>3, "ISL"=>4, "ISR"=>3, "ITA"=>2, "JAM"=>9, "JEY"=>6, "JOR"=>4, "JPN"=>5, "KAZ"=>6, "KEN"=>3, "KGZ"=>6, "KHM"=>6, "KIR"=>2, "KNA"=>2, "KOR"=>4, "KWT"=>4, "LAO"=>4, "LBN"=>4, "LBR"=>1, "LBY"=>5, "LCA"=>3, "LIE"=>4, "LKA"=>4, "LSO"=>8, "LTU"=>4, "LUX"=>2, "LVA"=>2, "MAC"=>5, "MAF"=>2, "MAR"=>2, "MCO"=>5, "MDA"=>7, "MDG"=>5, "MDV"=>9, "MEX"=>3, "MHL"=>7, "MKD"=>4, "MLI"=>3, "MLT"=>5, "MMR"=>3, "MNE"=>6, "MNG"=>5, "MNP"=>3, "MOZ"=>5, "MRT"=>2, "MSR"=>4, "MTQ"=>2, "MUS"=>7, "MWI"=>3, "MYS"=>4, "MYT"=>1, "NAM"=>3, "NCL"=>3, "NER"=>2, "NFK"=>5, "NGA"=>6, "NIC"=>1, "NIU"=>6, "NLD"=>4, "NOR"=>2, "NPL"=>8, "NRU"=>5, "NZL"=>4, "OMN"=>2, "PAK"=>2, "PAN"=>4, "PCN"=>10, "PER"=>5, "PHL"=>4, "PLW"=>1, "PNG"=>4, "POL"=>8, "PRI"=>4, "PRK"=>4, "PRT"=>2, "PRY"=>6, "PSE"=>4, "PYF"=>1, "QAT"=>5, "REU"=>3, "ROU"=>5, "RUS"=>2, "RWA"=>4, "SAU"=>3, "SDN"=>6, "SEN"=>1, "SGP"=>3, "SGS"=>6, "SHN"=>3, "SJM"=>4, "SLB"=>4, "SLE"=>3, "SLV"=>2, "SMR"=>2, "SOM"=>6, "SPM"=>8, "SRB"=>1, "SSD"=>7, "STP"=>5, "SUR"=>3, "SVK"=>2, "SVN"=>3, "SWE"=>7, "SWZ"=>5, "SXM"=>3, "SYC"=>4, "SYR"=>7, "TCA"=>5, "TCD"=>9, "TGO"=>1, "THA"=>4, "TJK"=>3, "TKL"=>6, "TKM"=>5, "TLS"=>5, "TON"=>1, "TTO"=>4, "TUN"=>6, "TUR"=>3, "TUV"=>6, "TWN"=>2, "TZA"=>3, "UGA"=>1, "UKR"=>2, "UMI"=>3, "URY"=>3, "USA"=>6, "UZB"=>4, "VAT"=>4, "VCT"=>2, "VEN"=>3, "VGB"=>4, "VIR"=>5, "VNM"=>4, "VUT"=>2, "WLF"=>2, "WSM"=>9, "YEM"=>3, "ZAF"=>2, "ZMB"=>3, "ZWE"=>3}
  end

  ###
  # Integration Testing
  ###

  # Without data

  def test_mapkick_world_without_data
    assert mapkick_world()
	end

  def test_mapkick_usa_without_data
    assert mapkick_usa()
  end

  # With data

  def test_mapkick_world_with_data
  	assert mapkick_world(@country_data)
  end

  def test_mapkick_usa_with_data
  	assert mapkick_usa(@state_data)
  end

  ###
  # Unit Testing
  ###

  def test_buckets
    assert_equal ["10 - 14", "15 - 18", "19 - 23", "24 - 27", "28 - 32"], buckets(@state_data, 5)
    assert_equal ["10 - 15", "16 - 20", "21 - 26", "27 - 32"], buckets(@state_data, 4)
  end

  def test_color
  	colors = ['A', 'B', 'C', 'D']
  	data = {'IL' => 1, 'IN' => 2, 'OH' => 4}
  	assert_equal 'B', color(data, 'IN', colors)
  	data = {'IL' => 1, 'IN' => 3, 'OH' => 4}
  	assert_equal 'C', color(data, 'IN', colors)
  	assert_equal 'A', color(data, 'IL', colors)
  	assert_equal 'D', color(data, 'OH', colors)
  end

  def test_bubble_radius
  	bubbles = [{radius: 1}, {radius: 2}, {radius: 3}]
  	assert_equal 10, bubble_radius(bubbles, bubbles.first, 10, 50)
  	assert_equal 50, bubble_radius(bubbles, bubbles.last, 10, 50)
  	assert_equal 30, bubble_radius(bubbles, bubbles[1], 10, 50)
  end

end